{ ******************************************************************
  Vector and matrix printing utilities
  ****************************************************************** }

unit matutils;

interface

uses
  utypes, ustrings;

{$define Vector array[Lb..Ub : Integer] of Float}

{$define Matrix array[Lb1..Ub1 : Integer; Lb2..Ub2 : Integer] of Float}

procedure WriteVector(Title : String; var V : Vector);
{ Writes a real vector }

procedure WriteMatrix(Title : String; var A : Matrix);
{ Writes a real matrix }

procedure WriteMatrixCols(Title : String; var A : Matrix; Col1, Col2 : Integer);
{ Writes a real matrix from Col1 to Col2 }

implementation

procedure WriteVector(Title : String; var V : Vector);
var
  I : Integer;
begin
  WriteLn(Title);
  WriteLn;
  for I := Lb to Ub do
    WriteLn(FloatStr(V[I]));
  WriteLn;
end;

procedure WriteMatrix(Title : String; var A : Matrix);
var
  I, J : Integer;
begin
  WriteLn(Title);
  WriteLn;
  for I := Lb1 to Ub1 do
    begin
      for J := Lb2 to Ub2 do
        Write(FloatStr(A[I,J]));
      WriteLn;
    end;
  WriteLn;
end;

procedure WriteMatrixCols(Title : String; var A : Matrix; Col1, Col2 : Integer);
var
  I, J : Integer;
begin
  WriteLn(Title);
  WriteLn;
  for I := Lb1 to Ub1 do
    begin
      for J := Col1 to Col2 do
        Write(FloatStr(A[I,J]));
      WriteLn;
    end;
  WriteLn;
end;

end.

