{ ******************************************************************
  This program solves a system of linear equations (A * X = B) with
  a single constant vector by the QR decomposition method.

  The file matrix3.inc is an example data file with N = 4
  ****************************************************************** }

program test_qr;

uses
  utypes, uqr, ustrings, matutils;

{$i matrix3.inc}

var
  R : array[1..N, 1..N] of Float;  { Matrix from QR decomp. }
  X : array[1..N] of Float;        { Solution vector }

begin
  SetFormat(12, 6, False, True);
  WriteMatrix('System matrix', A);
  WriteVector('Constant vector', B);

  { Perform QR decomposition of A. If successful, solve system }

  QR_Decomp(A, R);

  if MathErr = MatSing then
    begin
      WriteLn('Singular matrix!');
      Halt;
    end;

  QR_Solve(A, R, B, X);

  WriteVector('Solution vector', X);
end.
