{ ******************************************************************
  This program evaluates a rational fraction

                             1 + X + 2*X^2 + 3*X^3 + 4*X^4
  Example fraction is F(X) = -------------------------------
                             1 + 2*X - 3*X^2 + 4*X^3 - 5*X^4

  ****************************************************************** }

program evalfrac;

uses
  utypes, upolynom;

{ ------------------------------------------------------------------
  Define fraction here, in the form:

         Coef(0) + Coef(1) * X + ... + Coef(Deg1) * X^Deg1
  F(X) = -----------------------------------------------------
         1 + Coef(Deg1+1) * X + ... + Coef(Deg1+Deg2) * X^Deg2

  Note that the first coefficient of the denominator must be 1
  ------------------------------------------------------------------ }

  const Deg1 = 4; Deg2 = 4;

  var Coef : array[0 .. (Deg1 + Deg2)] of Float = 
             (1, 1, 2, 3, 4, 2, -3, 4, -5);

{ ------------------------------------------------------------------ }

var
 X, Y : Float;

begin
  repeat
    Write('X    =  ');
    ReadLn(X);
    Y := RFrac(X, Coef, Deg1, Deg2);
    WriteLn('F(X) = ', Y:12:6);
  until X = 0;
end.
