{ ******************************************************************
  Linear equation
  ****************************************************************** }

unit urtpol1;

interface

uses
  utypes;

{$define Vector array[Lb..Ub : Integer] of Float}

{$define CompVector array[LbC..UbC : Integer] of Complex}

function RootPol1(var Coef : Vector; var Z : CompVector) : Integer;
{ ------------------------------------------------------------------
  Solves the linear equation A + B * X = 0
  Returns  1 if no error (B <> 0)
          -1 if X is undetermined (A = B = 0)
          -2 if no solution (A <> 0, B = 0)
  ------------------------------------------------------------------ }

implementation

function RootPol1(var Coef : Vector; var Z : CompVector) : Integer;
var
  A, B : Float;
begin
  A := Coef[0];
  B := Coef[1];

  Z[1] := Cmplx(0.0, 0.0);

  if B <> 0.0 then
    begin
      if A <> 0.0 then Z[1] := Cmplx(- A / B, 0.0);
      RootPol1 := 1;
      Exit;
    end;

  if A = 0.0 then     { 0 + 0X = 0 }
    RootPol1 := - 1
  else                { A + 0X = 0 }
    RootPol1 := - 2;
end;

end.
